# coding: utf-8

"""
    Wavefront Public API

    <p>Wavefront public APIs enable you to interact with Wavefront servers using standard web service API tools. You can use the APIs to automate commonly executed operations such as automatically tagging sources.</p><p>When you make API calls outside the Wavefront UI you must add the header \"Authorization: Bearer &lt;&lt;API-TOKEN&gt;&gt;\" to your HTTP requests.</p><p>For legacy versions of the Wavefront API, see the <a href=\"/api-docs/ui/deprecated\">legacy API documentation</a>.</p>

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CloudWatchConfiguration(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, metric_filter_regex=None, base_credentials=None, instance_selection_tags=None, volume_selection_tags=None):
        """
        CloudWatchConfiguration - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'metric_filter_regex': 'str',
            'base_credentials': 'AWSBaseCredentials',
            'instance_selection_tags': 'dict(str, str)',
            'volume_selection_tags': 'dict(str, str)'
        }

        self.attribute_map = {
            'metric_filter_regex': 'metricFilterRegex',
            'base_credentials': 'baseCredentials',
            'instance_selection_tags': 'instanceSelectionTags',
            'volume_selection_tags': 'volumeSelectionTags'
        }

        self._metric_filter_regex = metric_filter_regex
        self._base_credentials = base_credentials
        self._instance_selection_tags = instance_selection_tags
        self._volume_selection_tags = volume_selection_tags

    @property
    def metric_filter_regex(self):
        """
        Gets the metric_filter_regex of this CloudWatchConfiguration.
        A regular expression that a CloudWatch metric name must match (case-insensitively) in order to be ingested

        :return: The metric_filter_regex of this CloudWatchConfiguration.
        :rtype: str
        """
        return self._metric_filter_regex

    @metric_filter_regex.setter
    def metric_filter_regex(self, metric_filter_regex):
        """
        Sets the metric_filter_regex of this CloudWatchConfiguration.
        A regular expression that a CloudWatch metric name must match (case-insensitively) in order to be ingested

        :param metric_filter_regex: The metric_filter_regex of this CloudWatchConfiguration.
        :type: str
        """

        self._metric_filter_regex = metric_filter_regex

    @property
    def base_credentials(self):
        """
        Gets the base_credentials of this CloudWatchConfiguration.

        :return: The base_credentials of this CloudWatchConfiguration.
        :rtype: AWSBaseCredentials
        """
        return self._base_credentials

    @base_credentials.setter
    def base_credentials(self, base_credentials):
        """
        Sets the base_credentials of this CloudWatchConfiguration.

        :param base_credentials: The base_credentials of this CloudWatchConfiguration.
        :type: AWSBaseCredentials
        """

        self._base_credentials = base_credentials

    @property
    def instance_selection_tags(self):
        """
        Gets the instance_selection_tags of this CloudWatchConfiguration.
        A comma-separated white list of AWS instance tag-value pairs (in AWS).  If the instance's AWS tags match this whitelist, CloudWatch data about this instance is ingested.  Multiple entries are OR'ed

        :return: The instance_selection_tags of this CloudWatchConfiguration.
        :rtype: dict(str, str)
        """
        return self._instance_selection_tags

    @instance_selection_tags.setter
    def instance_selection_tags(self, instance_selection_tags):
        """
        Sets the instance_selection_tags of this CloudWatchConfiguration.
        A comma-separated white list of AWS instance tag-value pairs (in AWS).  If the instance's AWS tags match this whitelist, CloudWatch data about this instance is ingested.  Multiple entries are OR'ed

        :param instance_selection_tags: The instance_selection_tags of this CloudWatchConfiguration.
        :type: dict(str, str)
        """

        self._instance_selection_tags = instance_selection_tags

    @property
    def volume_selection_tags(self):
        """
        Gets the volume_selection_tags of this CloudWatchConfiguration.
        A comma-separated white list of AWS volume tag-value pairs (in AWS).  If the volume's AWS tags match this whitelist, CloudWatch data about this volume is ingested.  Multiple entries are OR'ed

        :return: The volume_selection_tags of this CloudWatchConfiguration.
        :rtype: dict(str, str)
        """
        return self._volume_selection_tags

    @volume_selection_tags.setter
    def volume_selection_tags(self, volume_selection_tags):
        """
        Sets the volume_selection_tags of this CloudWatchConfiguration.
        A comma-separated white list of AWS volume tag-value pairs (in AWS).  If the volume's AWS tags match this whitelist, CloudWatch data about this volume is ingested.  Multiple entries are OR'ed

        :param volume_selection_tags: The volume_selection_tags of this CloudWatchConfiguration.
        :type: dict(str, str)
        """

        self._volume_selection_tags = volume_selection_tags

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CloudWatchConfiguration):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
