# coding: utf-8

"""
    Wavefront Public API

    <p>Wavefront public APIs enable you to interact with Wavefront servers using standard web service API tools. You can use the APIs to automate commonly executed operations such as automatically tagging sources.</p><p>When you make API calls outside the Wavefront UI you must add the header \"Authorization: Bearer &lt;&lt;API-TOKEN&gt;&gt;\" to your HTTP requests.</p><p>For legacy versions of the Wavefront API, see the <a href=\"/api-docs/ui/deprecated\">legacy API documentation</a>.</p>

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Proxy(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, id=None, version=None, last_check_in_time=None, hostname=None, last_known_error=None, last_error_time=None, last_error_event=None, time_drift=None, bytes_left_for_buffer=None, bytes_per_minute_for_buffer=None, local_queue_size=None, ssh_agent=None, ephemeral=None, in_trash=None, customer_id=None, deleted=None):
        """
        Proxy - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'id': 'str',
            'version': 'str',
            'last_check_in_time': 'int',
            'hostname': 'str',
            'last_known_error': 'str',
            'last_error_time': 'int',
            'last_error_event': 'Event',
            'time_drift': 'int',
            'bytes_left_for_buffer': 'int',
            'bytes_per_minute_for_buffer': 'int',
            'local_queue_size': 'int',
            'ssh_agent': 'bool',
            'ephemeral': 'bool',
            'in_trash': 'bool',
            'customer_id': 'str',
            'deleted': 'bool'
        }

        self.attribute_map = {
            'name': 'name',
            'id': 'id',
            'version': 'version',
            'last_check_in_time': 'lastCheckInTime',
            'hostname': 'hostname',
            'last_known_error': 'lastKnownError',
            'last_error_time': 'lastErrorTime',
            'last_error_event': 'lastErrorEvent',
            'time_drift': 'timeDrift',
            'bytes_left_for_buffer': 'bytesLeftForBuffer',
            'bytes_per_minute_for_buffer': 'bytesPerMinuteForBuffer',
            'local_queue_size': 'localQueueSize',
            'ssh_agent': 'sshAgent',
            'ephemeral': 'ephemeral',
            'in_trash': 'inTrash',
            'customer_id': 'customerId',
            'deleted': 'deleted'
        }

        self._name = name
        self._id = id
        self._version = version
        self._last_check_in_time = last_check_in_time
        self._hostname = hostname
        self._last_known_error = last_known_error
        self._last_error_time = last_error_time
        self._last_error_event = last_error_event
        self._time_drift = time_drift
        self._bytes_left_for_buffer = bytes_left_for_buffer
        self._bytes_per_minute_for_buffer = bytes_per_minute_for_buffer
        self._local_queue_size = local_queue_size
        self._ssh_agent = ssh_agent
        self._ephemeral = ephemeral
        self._in_trash = in_trash
        self._customer_id = customer_id
        self._deleted = deleted

    @property
    def name(self):
        """
        Gets the name of this Proxy.
        Proxy name (modifiable)

        :return: The name of this Proxy.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this Proxy.
        Proxy name (modifiable)

        :param name: The name of this Proxy.
        :type: str
        """

        self._name = name

    @property
    def id(self):
        """
        Gets the id of this Proxy.

        :return: The id of this Proxy.
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this Proxy.

        :param id: The id of this Proxy.
        :type: str
        """

        self._id = id

    @property
    def version(self):
        """
        Gets the version of this Proxy.

        :return: The version of this Proxy.
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """
        Sets the version of this Proxy.

        :param version: The version of this Proxy.
        :type: str
        """

        self._version = version

    @property
    def last_check_in_time(self):
        """
        Gets the last_check_in_time of this Proxy.
        Last time when this proxy checked in (in milliseconds since the unix epoch)

        :return: The last_check_in_time of this Proxy.
        :rtype: int
        """
        return self._last_check_in_time

    @last_check_in_time.setter
    def last_check_in_time(self, last_check_in_time):
        """
        Sets the last_check_in_time of this Proxy.
        Last time when this proxy checked in (in milliseconds since the unix epoch)

        :param last_check_in_time: The last_check_in_time of this Proxy.
        :type: int
        """

        self._last_check_in_time = last_check_in_time

    @property
    def hostname(self):
        """
        Gets the hostname of this Proxy.
        Host name of the machine running the proxy

        :return: The hostname of this Proxy.
        :rtype: str
        """
        return self._hostname

    @hostname.setter
    def hostname(self, hostname):
        """
        Sets the hostname of this Proxy.
        Host name of the machine running the proxy

        :param hostname: The hostname of this Proxy.
        :type: str
        """

        self._hostname = hostname

    @property
    def last_known_error(self):
        """
        Gets the last_known_error of this Proxy.
        deprecated

        :return: The last_known_error of this Proxy.
        :rtype: str
        """
        return self._last_known_error

    @last_known_error.setter
    def last_known_error(self, last_known_error):
        """
        Sets the last_known_error of this Proxy.
        deprecated

        :param last_known_error: The last_known_error of this Proxy.
        :type: str
        """

        self._last_known_error = last_known_error

    @property
    def last_error_time(self):
        """
        Gets the last_error_time of this Proxy.
        deprecated

        :return: The last_error_time of this Proxy.
        :rtype: int
        """
        return self._last_error_time

    @last_error_time.setter
    def last_error_time(self, last_error_time):
        """
        Sets the last_error_time of this Proxy.
        deprecated

        :param last_error_time: The last_error_time of this Proxy.
        :type: int
        """

        self._last_error_time = last_error_time

    @property
    def last_error_event(self):
        """
        Gets the last_error_event of this Proxy.

        :return: The last_error_event of this Proxy.
        :rtype: Event
        """
        return self._last_error_event

    @last_error_event.setter
    def last_error_event(self, last_error_event):
        """
        Sets the last_error_event of this Proxy.

        :param last_error_event: The last_error_event of this Proxy.
        :type: Event
        """

        self._last_error_event = last_error_event

    @property
    def time_drift(self):
        """
        Gets the time_drift of this Proxy.
        Time drift of the proxy's clock compared to Wavefront servers

        :return: The time_drift of this Proxy.
        :rtype: int
        """
        return self._time_drift

    @time_drift.setter
    def time_drift(self, time_drift):
        """
        Sets the time_drift of this Proxy.
        Time drift of the proxy's clock compared to Wavefront servers

        :param time_drift: The time_drift of this Proxy.
        :type: int
        """

        self._time_drift = time_drift

    @property
    def bytes_left_for_buffer(self):
        """
        Gets the bytes_left_for_buffer of this Proxy.
        Number of bytes of space remaining in the persistent disk queue of this proxy

        :return: The bytes_left_for_buffer of this Proxy.
        :rtype: int
        """
        return self._bytes_left_for_buffer

    @bytes_left_for_buffer.setter
    def bytes_left_for_buffer(self, bytes_left_for_buffer):
        """
        Sets the bytes_left_for_buffer of this Proxy.
        Number of bytes of space remaining in the persistent disk queue of this proxy

        :param bytes_left_for_buffer: The bytes_left_for_buffer of this Proxy.
        :type: int
        """

        self._bytes_left_for_buffer = bytes_left_for_buffer

    @property
    def bytes_per_minute_for_buffer(self):
        """
        Gets the bytes_per_minute_for_buffer of this Proxy.
        Bytes used per minute by the persistent disk queue of this proxy

        :return: The bytes_per_minute_for_buffer of this Proxy.
        :rtype: int
        """
        return self._bytes_per_minute_for_buffer

    @bytes_per_minute_for_buffer.setter
    def bytes_per_minute_for_buffer(self, bytes_per_minute_for_buffer):
        """
        Sets the bytes_per_minute_for_buffer of this Proxy.
        Bytes used per minute by the persistent disk queue of this proxy

        :param bytes_per_minute_for_buffer: The bytes_per_minute_for_buffer of this Proxy.
        :type: int
        """

        self._bytes_per_minute_for_buffer = bytes_per_minute_for_buffer

    @property
    def local_queue_size(self):
        """
        Gets the local_queue_size of this Proxy.
        Number of items in the persistent disk queue of this proxy

        :return: The local_queue_size of this Proxy.
        :rtype: int
        """
        return self._local_queue_size

    @local_queue_size.setter
    def local_queue_size(self, local_queue_size):
        """
        Sets the local_queue_size of this Proxy.
        Number of items in the persistent disk queue of this proxy

        :param local_queue_size: The local_queue_size of this Proxy.
        :type: int
        """

        self._local_queue_size = local_queue_size

    @property
    def ssh_agent(self):
        """
        Gets the ssh_agent of this Proxy.
        deprecated

        :return: The ssh_agent of this Proxy.
        :rtype: bool
        """
        return self._ssh_agent

    @ssh_agent.setter
    def ssh_agent(self, ssh_agent):
        """
        Sets the ssh_agent of this Proxy.
        deprecated

        :param ssh_agent: The ssh_agent of this Proxy.
        :type: bool
        """

        self._ssh_agent = ssh_agent

    @property
    def ephemeral(self):
        """
        Gets the ephemeral of this Proxy.
        When true, this proxy is expected to be ephemeral (possibly hosted on a short-lived container) and will be deleted after a period of inactivity (not checking in)

        :return: The ephemeral of this Proxy.
        :rtype: bool
        """
        return self._ephemeral

    @ephemeral.setter
    def ephemeral(self, ephemeral):
        """
        Sets the ephemeral of this Proxy.
        When true, this proxy is expected to be ephemeral (possibly hosted on a short-lived container) and will be deleted after a period of inactivity (not checking in)

        :param ephemeral: The ephemeral of this Proxy.
        :type: bool
        """

        self._ephemeral = ephemeral

    @property
    def in_trash(self):
        """
        Gets the in_trash of this Proxy.

        :return: The in_trash of this Proxy.
        :rtype: bool
        """
        return self._in_trash

    @in_trash.setter
    def in_trash(self, in_trash):
        """
        Sets the in_trash of this Proxy.

        :param in_trash: The in_trash of this Proxy.
        :type: bool
        """

        self._in_trash = in_trash

    @property
    def customer_id(self):
        """
        Gets the customer_id of this Proxy.

        :return: The customer_id of this Proxy.
        :rtype: str
        """
        return self._customer_id

    @customer_id.setter
    def customer_id(self, customer_id):
        """
        Sets the customer_id of this Proxy.

        :param customer_id: The customer_id of this Proxy.
        :type: str
        """

        self._customer_id = customer_id

    @property
    def deleted(self):
        """
        Gets the deleted of this Proxy.

        :return: The deleted of this Proxy.
        :rtype: bool
        """
        return self._deleted

    @deleted.setter
    def deleted(self, deleted):
        """
        Sets the deleted of this Proxy.

        :param deleted: The deleted of this Proxy.
        :type: bool
        """

        self._deleted = deleted

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Proxy):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
