# coding: utf-8

"""
    Wavefront Public API

    <p>Wavefront public APIs enable you to interact with Wavefront servers using standard web service API tools. You can use the APIs to automate commonly executed operations such as automatically tagging sources.</p><p>When you make API calls outside the Wavefront UI you must add the header \"Authorization: Bearer &lt;&lt;API-TOKEN&gt;&gt;\" to your HTTP requests.</p><p>For legacy versions of the Wavefront API, see the <a href=\"/api-docs/ui/deprecated\">legacy API documentation</a>.</p>

    OpenAPI spec version: v2
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ReportEvent(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, name=None, start_time=None, end_time=None, annotations=None, hosts=None, summarized_events=None, tags=None, is_user_event=None, is_ephemeral=None, table=None, creator_id=None, updater_id=None, created_at=None, updated_at=None):
        """
        ReportEvent - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'name': 'str',
            'start_time': 'int',
            'end_time': 'int',
            'annotations': 'dict(str, str)',
            'hosts': 'list[str]',
            'summarized_events': 'int',
            'tags': 'list[str]',
            'is_user_event': 'bool',
            'is_ephemeral': 'bool',
            'table': 'str',
            'creator_id': 'str',
            'updater_id': 'str',
            'created_at': 'int',
            'updated_at': 'int'
        }

        self.attribute_map = {
            'name': 'name',
            'start_time': 'startTime',
            'end_time': 'endTime',
            'annotations': 'annotations',
            'hosts': 'hosts',
            'summarized_events': 'summarizedEvents',
            'tags': 'tags',
            'is_user_event': 'isUserEvent',
            'is_ephemeral': 'isEphemeral',
            'table': 'table',
            'creator_id': 'creatorId',
            'updater_id': 'updaterId',
            'created_at': 'createdAt',
            'updated_at': 'updatedAt'
        }

        self._name = name
        self._start_time = start_time
        self._end_time = end_time
        self._annotations = annotations
        self._hosts = hosts
        self._summarized_events = summarized_events
        self._tags = tags
        self._is_user_event = is_user_event
        self._is_ephemeral = is_ephemeral
        self._table = table
        self._creator_id = creator_id
        self._updater_id = updater_id
        self._created_at = created_at
        self._updated_at = updated_at

    @property
    def name(self):
        """
        Gets the name of this ReportEvent.
        Name of the event

        :return: The name of this ReportEvent.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ReportEvent.
        Name of the event

        :param name: The name of this ReportEvent.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def start_time(self):
        """
        Gets the start_time of this ReportEvent.
        Start time in milliseconds for the event

        :return: The start_time of this ReportEvent.
        :rtype: int
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """
        Sets the start_time of this ReportEvent.
        Start time in milliseconds for the event

        :param start_time: The start_time of this ReportEvent.
        :type: int
        """
        if start_time is None:
            raise ValueError("Invalid value for `start_time`, must not be `None`")

        self._start_time = start_time

    @property
    def end_time(self):
        """
        Gets the end_time of this ReportEvent.
        End time in milliseconds for the event. If missing, the event is ongoing

        :return: The end_time of this ReportEvent.
        :rtype: int
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """
        Sets the end_time of this ReportEvent.
        End time in milliseconds for the event. If missing, the event is ongoing

        :param end_time: The end_time of this ReportEvent.
        :type: int
        """

        self._end_time = end_time

    @property
    def annotations(self):
        """
        Gets the annotations of this ReportEvent.
        Annotations for the event. Searchable during queries

        :return: The annotations of this ReportEvent.
        :rtype: dict(str, str)
        """
        return self._annotations

    @annotations.setter
    def annotations(self, annotations):
        """
        Sets the annotations of this ReportEvent.
        Annotations for the event. Searchable during queries

        :param annotations: The annotations of this ReportEvent.
        :type: dict(str, str)
        """

        self._annotations = annotations

    @property
    def hosts(self):
        """
        Gets the hosts of this ReportEvent.
        Hosts associated for the event

        :return: The hosts of this ReportEvent.
        :rtype: list[str]
        """
        return self._hosts

    @hosts.setter
    def hosts(self, hosts):
        """
        Sets the hosts of this ReportEvent.
        Hosts associated for the event

        :param hosts: The hosts of this ReportEvent.
        :type: list[str]
        """

        self._hosts = hosts

    @property
    def summarized_events(self):
        """
        Gets the summarized_events of this ReportEvent.

        :return: The summarized_events of this ReportEvent.
        :rtype: int
        """
        return self._summarized_events

    @summarized_events.setter
    def summarized_events(self, summarized_events):
        """
        Sets the summarized_events of this ReportEvent.

        :param summarized_events: The summarized_events of this ReportEvent.
        :type: int
        """

        self._summarized_events = summarized_events

    @property
    def tags(self):
        """
        Gets the tags of this ReportEvent.

        :return: The tags of this ReportEvent.
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this ReportEvent.

        :param tags: The tags of this ReportEvent.
        :type: list[str]
        """

        self._tags = tags

    @property
    def is_user_event(self):
        """
        Gets the is_user_event of this ReportEvent.

        :return: The is_user_event of this ReportEvent.
        :rtype: bool
        """
        return self._is_user_event

    @is_user_event.setter
    def is_user_event(self, is_user_event):
        """
        Sets the is_user_event of this ReportEvent.

        :param is_user_event: The is_user_event of this ReportEvent.
        :type: bool
        """

        self._is_user_event = is_user_event

    @property
    def is_ephemeral(self):
        """
        Gets the is_ephemeral of this ReportEvent.

        :return: The is_ephemeral of this ReportEvent.
        :rtype: bool
        """
        return self._is_ephemeral

    @is_ephemeral.setter
    def is_ephemeral(self, is_ephemeral):
        """
        Sets the is_ephemeral of this ReportEvent.

        :param is_ephemeral: The is_ephemeral of this ReportEvent.
        :type: bool
        """

        self._is_ephemeral = is_ephemeral

    @property
    def table(self):
        """
        Gets the table of this ReportEvent.
        The customer that owns the event

        :return: The table of this ReportEvent.
        :rtype: str
        """
        return self._table

    @table.setter
    def table(self, table):
        """
        Sets the table of this ReportEvent.
        The customer that owns the event

        :param table: The table of this ReportEvent.
        :type: str
        """

        self._table = table

    @property
    def creator_id(self):
        """
        Gets the creator_id of this ReportEvent.

        :return: The creator_id of this ReportEvent.
        :rtype: str
        """
        return self._creator_id

    @creator_id.setter
    def creator_id(self, creator_id):
        """
        Sets the creator_id of this ReportEvent.

        :param creator_id: The creator_id of this ReportEvent.
        :type: str
        """

        self._creator_id = creator_id

    @property
    def updater_id(self):
        """
        Gets the updater_id of this ReportEvent.

        :return: The updater_id of this ReportEvent.
        :rtype: str
        """
        return self._updater_id

    @updater_id.setter
    def updater_id(self, updater_id):
        """
        Sets the updater_id of this ReportEvent.

        :param updater_id: The updater_id of this ReportEvent.
        :type: str
        """

        self._updater_id = updater_id

    @property
    def created_at(self):
        """
        Gets the created_at of this ReportEvent.

        :return: The created_at of this ReportEvent.
        :rtype: int
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this ReportEvent.

        :param created_at: The created_at of this ReportEvent.
        :type: int
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """
        Gets the updated_at of this ReportEvent.

        :return: The updated_at of this ReportEvent.
        :rtype: int
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """
        Sets the updated_at of this ReportEvent.

        :param updated_at: The updated_at of this ReportEvent.
        :type: int
        """

        self._updated_at = updated_at

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ReportEvent):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
